# Shortcut Keys

Here are all the hotkeys/shortcuts used within Sketchy Maze.

* [Global Shortcuts](#global-shortcuts)
* [Level Editor](#editor-only)
* [Gameplay](#gameplay-only)

## Global Shortcuts

| Key      | Action                                                     |
|----------|------------------------------------------------------------|
| `Escape` | Exit the application (after confirmation modal).           |
| `F1`     | Open the Guidebook (this site).                            |
| <code>`</code> | Open the [developer console](hacking.md#developer-console) |

---

## Editor Only

Only while editing a level or doodad:

| Key      | Action                                               |
|----------|------------------------------------------------------|
| Arrows   | Scroll the view of the level you're editing.         |
| `p`      | Playtest the current level (press `e` to edit again) |
| `d`      | Open the Doodads window to drop them in your level   |
| `v`      | Open a new Viewport window into your level           |
| `f`      | Pencil Tool (**f**reehand)                           |
| `l`      | **L**ine Tool                                        |
| `r`      | **R**ectangle Tool                                   |
| `c`      | Ellipse Tool (**c**ircles)                           |
| `x`      | Eraser Tool                                          |
| `+=`     | Zoom in                                              |
| `-_`     | Zoom out                                             |
| `1`      | Reset zoom                                           |
| `0`      | Scroll level back to origin (0,0)                    |
| `Backspace` | Close the top-most popup window.                  |
| `Shift+Backspace` | Close _all_ popup windows.                  |
| `Ctrl-N` | Create a new level                                   |
| `Ctrl-S` | Save the current drawing                             |
| `Ctrl-O` | Open a drawing                                       |
| `Ctrl-Z` | Undo                                                 |
| `Ctrl-Y` | Redo                                                 |

&nbsp;

### Mouse gestures

* Middle-click + drag: pan scroll the level viewport.

### Multi-touch gestures

* Two-finger drag: pan scroll the level viewport.

---

## Gameplay Only

### Keyboard controls

| Key            | Action                                       |
|----------------|----------------------------------------------|
| `Left` or `a`  | Move the player character towards the left.  |
| `Right` or `d` | Move the player character towards the right. |
| `Up` or `w`    | Jump                                         |
| `Down` or `s`  | Move the player downward (antigravity only)  |
| `e`            | Return to the level editor                   |

&nbsp;

### Touch controls

* Touch the "middle" of the screen to open Warp Doors or use other
  objects that the player character is nearby.
* Touch anywhere **left** of that "middle" to move left, and touch
  **right** of that "middle" to move right.
* Touch anywhere **above** that middle to jump. The left and right
  regions of the screen will jump and move in that direction.
* For antigravity, touch anywhere **below** to move downward.

&nbsp;
